// This script outputs the name and description of all of the prims
// in the linkset.
// It has three ways to do this: set 'METHOD' to the method that you prefer.
// (However, method 1 can only show the name, not the description.)

integer numPrims;
integer firstPrim;
integer lastPrim;

integer METHOD = 3;

default
{
    state_entry()
    {
    }

    touch_start(integer num)
    {
        numPrims = llGetObjectPrimCount(llGetKey());
        if (numPrims == 1) {
            firstPrim = lastPrim = 0;
        }
        else {
            firstPrim = 1;
            lastPrim = numPrims;
        }

        integer link;
        for (link = firstPrim; link <= lastPrim; ++link)
        {
            string name;
            string description;
            
            if (METHOD == 1) {
                name = llGetLinkName(link);
                description = "";
            }
            else if (METHOD == 2) {
                list details = llGetObjectDetails(llGetLinkKey(link),
                    ([OBJECT_NAME, OBJECT_DESC]));
                name = llList2String(details, 0);
                description = llList2String(details, 1);
            }
            else if (METHOD == 3) {
                list details = llGetLinkPrimitiveParams(link,
                    ([PRIM_NAME, PRIM_DESC]));
                name = llList2String(details, 0);
                description = llList2String(details, 1);
            }
            
            string msg = name;
            if (description != "")
                msg += " (" + description + ")";

            llOwnerSay("Prim " + (string)link + " = " + msg);
        }
    }
}